// GLASS Shader & Decals
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _909
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1169
{
    int _m0;
    int _m1;
};

struct _1172
{
    int _m0;
    int _m1;
};

struct _1283
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2150
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3484
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 0, binding = 0, std140) uniform _930_932
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _932;

layout(set = 2, binding = 0, std140) uniform _1013_1015
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _1015;

layout(set = 1, binding = 0, std140) uniform _1063_1065
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _1065;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1174_1176
{
    _1172 _m0[];
} _1176;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1258_1260
{
    uint _m0[];
} _1260;

layout(set = 0, binding = 6, std140) uniform _1288_1290
{
    vec4 _m0[4096];
} _1290;

layout(set = 0, binding = 7, std140) uniform _1308_1310
{
    vec4 _m0[4096];
} _1310;

layout(set = 0, binding = 8, std140) uniform _1360_1362
{
    vec4 _m0[4096];
} _1362;

layout(set = 0, binding = 10, std140) uniform _2154_2156
{
    vec4 _m0[4096];
} _2156;

layout(set = 0, binding = 11, std140) uniform _2193_2195
{
    vec4 _m0[4096];
} _2195;

layout(set = 0, binding = 12, std140) uniform _2262_2264
{
    vec4 _m0[3072];
} _2264;

layout(set = 0, binding = 15, std140) uniform _3488_3490
{
    vec4 _m0[4095];
} _3490;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4779_4781
{
    vec4 _m0[];
} _4781;

layout(push_constant, std430) uniform _4775_4777
{
    int _m0;
    int _m1;
} _4777;

layout(set = 2, binding = 1) uniform SAMPLER_2D _1021;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1029;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1034;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1582;
layout(set = 0, binding = 13) uniform samplerCubeArray _2660;
layout(set = 0, binding = 14) uniform SAMPLER_2D _3046;
layout(set = 0, binding = 16) uniform sampler2DShadow _3811;
layout(set = 0, binding = 17) uniform SAMPLER_2D _4276;
layout(set = 0, binding = 18) uniform SAMPLER_2D _4298;
layout(set = 0, binding = 19) uniform SAMPLER_2D _4337;
layout(set = 0, binding = 20) uniform SAMPLER_2D _4376;
layout(set = 0, binding = 21) uniform SAMPLER_2D _4411;
layout(set = 0, binding = 22) uniform sampler3D _4542;
layout(set = 0, binding = 23) uniform sampler3D _4563;
layout(set = 0, binding = 24) uniform sampler3D _4683;
layout(set = 0, binding = 25) uniform SAMPLER_2D _4746;
layout(set = 0, binding = 2) uniform sampler3D _4782;
layout(set = 0, binding = 3) uniform sampler3D _4783;

layout(location = 2) in vec4 _923;
layout(location = 6) in vec4 _937;
layout(location = 3) in vec4 _949;
layout(location = 4) in vec4 _952;
layout(location = 5) in vec4 _955;
layout(location = 10) in vec4 _973;
layout(location = 11) in vec4 _977;
layout(location = 12) in vec4 _981;
layout(location = 0) out vec4 _4460;
layout(location = 1) out vec4 _4727;
layout(location = 2) out vec4 _4728;

float _284;

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _286 = _53.x;
    vec3 _285;
    _285.x = _51(_286);
    float _292 = _53.y;
    _285.y = _51(_292);
    float _298 = _53.z;
    _285.z = _51(_298);
    return _285;
}

vec4 _57(vec4 _56)
{
    vec3 _308 = _56.xyz;
    vec4 _307 = vec4(_54(_308), 1.0);
    float _316 = _56.w;
    _307.w = _51(_316);
    return _307;
}

vec4 _69(vec4 _68)
{
    vec4 _374 = _68;
    return _57(_374);
}

vec4 _128(SAMPLER_2D _126, vec2 _127)
{
    vec4 _653 = SAMPLE_TEXTURE(_126, _127);
    vec4 _657 = _653;
    _653 = _69(_657);
    return _653;
}

float _166(float _162, vec4 _163, float _164, bool _165)
{
    float _845 = _163.w / (_162 + _163.z);
    return _845 * _164;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

vec3 _171(vec3 _169, bool _170)
{
    vec3 _858 = (_169 * 2.0) - vec3(1.0);
    float _875 = (1.0 - (_858.x * _858.x)) - (_858.y * _858.y);
    _858.z = sqrt(_14(_875));
    if (_170 == false)
    {
        _858.z = -_858.z;
    }
    return _858;
}

vec3 _178(vec3 _176, mat3 _177)
{
    return normalize(vec3(dot(_176, _177[0]), dot(_176, _177[1]), dot(_176, _177[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _105(uint _104)
{
    return unpackUnorm4x8(_104).wzyx;
}

vec4 _118(uvec2 _117)
{
    return vec4(float((_117.x >> uint(16)) & 65535u), float(_117.x & 65535u), float((_117.y >> uint(16)) & 65535u), float(_117.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _135(SAMPLER_2D _131, vec2 _132, vec2 _133, vec2 _134)
{
    return TEXTURE_GRAD(_131, _132, _133, _134);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

float _60(float _59)
{
    return _59 * ((_59 * ((_59 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _108(uint _107)
{
    return vec4(float((_107 >> uint(24)) & 255u), float((_107 >> uint(16)) & 255u), float((_107 >> uint(8)) & 255u), float(_107 & 255u));
}

vec3 _63(vec3 _62)
{
    float _339 = _62.x;
    vec3 _338;
    _338.x = _60(_339);
    float _344 = _62.y;
    _338.y = _60(_344);
    float _349 = _62.z;
    _338.z = _60(_349);
    return _338;
}

vec4 _66(vec4 _65)
{
    vec3 _358 = _65.xyz;
    vec4 _357 = vec4(_63(_358), 1.0);
    float _366 = _65.w;
    _357.w = _60(_366);
    return _357;
}

float _87(float _86)
{
    return (step(0.0, _86) * 2.0) - 1.0;
}

vec4 _26(vec4 _25)
{
    return clamp(_25, vec4(0.0), vec4(1.0));
}

float _79(float _78)
{
    return exp2(_78);
}

vec3 _138(uint _137)
{
    uint _671 = _137;
    vec4 _670 = _105(_671);
    float _682 = (_670.w * 255.0) - 128.0;
    return _670.xyz * _79(_682);
}

vec3 _157(float _154, float _155, vec3 _156)
{
    float _797 = 0.0949999988079071044921875 + (_155 * (0.60000002384185791015625 + (4.190000057220458984375 * _155)));
    float _807 = _154 + 0.02500000037252902984619140625;
    float _811 = (9.5 * _155) * _154;
    float _825 = 1.0 - (14.0 * _154);
    float _817 = (_797 * _807) * _79(_825);
    float _832 = -_811;
    float _828 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _79(_832)));
    return mix(vec3(_817), vec3(_828), _156);
}

vec3 _112(uint _111)
{
    return vec3(float((_111 >> uint(21)) & 2047u), float((_111 >> uint(10)) & 2047u), float(_111 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _48(float _45, float _46, float _47)
{
    bool _225 = abs(_47) >= abs(_45);
    bool _233;
    if (_225)
    {
        _233 = abs(_47) >= abs(_46);
    }
    else
    {
        _233 = _225;
    }
    if (_233)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _84(float _82, float _83)
{
    return pow(_82, _83);
}

vec3 _20(vec3 _19)
{
    return clamp(_19, vec3(0.0), vec3(1.0));
}

vec3 _143(vec3 _141, float _142)
{
    float _694 = 50.0 * dot(_141, vec3(0.33329999446868896484375));
    float _687 = _14(_694);
    float _703 = 1.0 - _142;
    float _706 = _14(_703);
    float _707 = 5.0;
    vec3 _711 = _141 + ((vec3(_687) - _141) * _84(_706, _707));
    return _20(_711);
}

vec3 _151(vec3 _146, vec3 _147, vec3 _148, vec3 _149, float _150)
{
    vec3 _715 = normalize(_147 + _148);
    float _720 = 1.0 - (_150 * 0.800000011920928955078125);
    _720 *= _720;
    _720 *= _720;
    float _731 = _720 * _720;
    float _739 = dot(_146, _715);
    float _735 = _14(_739);
    float _741 = ((_735 * _735) * (_731 - 1.0)) + 1.0;
    _741 = _731 / ((_741 * _741) + 9.9999999392252902907785028219223e-09);
    float _760 = dot(_146, _147);
    float _756 = (_14(_760) * (1.0 - _720)) + _720;
    float _771 = dot(_146, _148);
    float _767 = (_14(_771) * (1.0 - _720)) + _720;
    _741 /= (((4.0 * _756) * _767) + 9.9999999392252902907785028219223e-09);
    vec3 _789 = _149;
    float _791 = dot(_148, _715);
    return _143(_789, _791) * _741;
}

vec4 _76(vec3 _74, mat4 _75)
{
    return vec4((_74.x * _75[0].x) + ((_74.y * _75[0].y) + ((_74.z * _75[0].z) + _75[0].w)), (_74.x * _75[1].x) + ((_74.y * _75[1].y) + ((_74.z * _75[1].z) + _75[1].w)), (_74.x * _75[2].x) + ((_74.y * _75[2].y) + ((_74.z * _75[2].z) + _75[2].w)), (_74.x * _75[3].x) + ((_74.y * _75[3].y) + ((_74.z * _75[3].z) + _75[3].w)));
}

float _90(float _89)
{
    float _478 = (((-0.15658299624919891357421875) * abs(_89)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_89));
    float _492;
    if (_89 >= 0.0)
    {
        _492 = _478;
    }
    else
    {
        _492 = 3.1415927410125732421875 - _478;
    }
    return _492;
}

float _93(float _92)
{
    float _506;
    if (_92 < 1.0)
    {
        _506 = _92;
    }
    else
    {
        _506 = 1.0 / _92;
    }
    float _503 = _506;
    float _514 = _503 * _503;
    float _518 = 0.087292902171611785888671875;
    _518 = (-0.3018949925899505615234375) + (_518 * _514);
    _518 = 1.0 + (_518 * _514);
    _518 *= _503;
    float _534;
    if (_92 < 1.0)
    {
        _534 = _518;
    }
    else
    {
        _534 = 1.57079637050628662109375 - _518;
    }
    return _534;
}

float _96(float _95)
{
    float _547 = abs(_95);
    float _544 = _93(_547);
    float _551;
    if (_95 < 0.0)
    {
        _551 = -_544;
    }
    else
    {
        _551 = _544;
    }
    return _551;
}

float _100(float _98, float _99)
{
    float _565 = _98 / _99;
    float _561 = _96(_565);
    if (_99 < 0.0)
    {
        _561 += ((_98 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _561;
}

void main()
{
    _909 _911 = _909(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _911._m15 = _923;
    _911._m16 = gl_FragCoord;
    _911._m14 = _932._m4.xyz + _937.xyz;
    _911._m13 = normalize(-_937.xyz);
    _911._m17 = mat3(vec3(_949.xyz), vec3(_952.xyz), vec3(_955.xyz));
    _911._m34 = _973;
    _911._m35 = _977;
    _911._m36 = _981;
    uint _984 = 0u;
    vec4 _985 = vec4(0.0);
    vec4 _986 = vec4(0.0);
    vec4 _987 = vec4(0.0);
    vec4 _988 = vec4(0.0);
    vec4 _989 = vec4(0.0);
    _911._m0 = _987.xyz;
    _911._m2 = _988.xyz;
    _911._m1 = _986.xyz;
    _911._m9 = _985.xyz;
    _911._m3 = _985.w;
    _911._m6 = _989.wyz;
    vec2 _1010 = _923.xy * _1015._m2.xy;
    vec2 _1022 = _1010;
    vec4 _1020 = _128(_1021, _1022);
    vec4 _1025 = vec4(0.07999999821186065673828125);
    vec4 _1028 = SAMPLE_TEXTURE(_1029, _1010);
    float _1033 = SAMPLE_TEXTURE(_1034, _1010).x;
    _911._m0 = _1015._m3.xyz * _1020.xyz;
    _911._m11 = _1015._m3.w * _1020.w;
    _911._m2 = _1025.xyz;
    _911._m3 = _1033;
    _911._m6 = _1028.xyz;
    uint _1062 = uint((_1065._m6.x > 0.0) ? 8 : 0);
    float _1071 = 16.0;
    float _1073 = 8.0;
    float _1075 = 24.0;
    vec2 _1084 = _911._m16.xy * _932._m6.xy;
    vec3 _1077;
    _1077 = vec3(_1084.x, _1084.y, _1077.z);
    _1077.y = 1.0 - _1077.y;

    // FIX FOR DECALS CLIPPING
    _1077.x -= vk3d_params[VIEW].stereo.x * 0.5;

    vec2 _1097 = floor(_1077.xy * vec2(_1071, _1073));
    _1077 = vec3(_1097.x, _1097.y, _1077.z);
    float _1102 = _911._m16.z;
    vec4 _1105 = _932._m7;
    float _1108 = 1.0;
    bool _1109 = false;
    float _1100 = _166(_1102, _1105, _1108, _1109);
    float _1111 = log2(max(1.0, _1100 / _932._m8.z)) * _932._m8.w;
    _1077.z = min(_1075 - 1.0, floor(_1111));
    uint _1127 = uint((_1077.x + (_1077.y * _1071)) + ((_1077.z * _1071) * _1073));
    bool _1143 = true;
    vec3 _1145 = _911._m6;
    bool _1148 = _1143;
    _911._m7 = _171(_1145, _1148);
    vec3 _1152 = _911._m7;
    mat3 _1155 = _911._m17;
    _911._m6 = _178(_1152, _1155);
    uint _1160 = 0u;
    uint _1161 = 0u;
    uint _1162 = 0u;
    uint _1163 = 0u;
    uint _1164 = 0u;
    uint _1165 = 0u;
    int _1167 = 256;
    _1169 _1171;
    _1171._m0 = _1176._m0[_1127]._m0;
    _1171._m1 = _1176._m0[_1127]._m1;
    int _1185 = _1171._m0 & (~(_1171._m0 >> 31));
    int _1194 = _1171._m1 & (~(_1171._m1 >> 31));
    _1160 = uint((_1185 >> 16) * _1167);
    _1161 = _1160 + uint(_1194 & 255);
    _1162 = _1160;
    _1163 = _1162 + uint((_1194 >> 8) & 255);
    _1164 = _1160;
    _1165 = _1164 + uint((_1194 >> 16) & 255);
    vec3 _1227 = dFdx(_911._m14);
    vec3 _1231 = dFdy(_911._m14);
    bool _1236 = _1062 == 0u;
    bool _1242;
    if (_1236)
    {
        _1242 = _1065._m6.y == 0.0;
    }
    else
    {
        _1242 = _1236;
    }
    _1162 = _1242 ? _1163 : _1162;
    uint _1246 = _1162;
    _1283 _1285;
    vec3 _1650;
    float _1783;
    while (_1246 < _1163)
    {
        uint _1256 = _1260._m0[_1246];
        uint _1265 = (_1256 >> uint(12)) & 4095u;
        uint _1271 = _1265;
        if (_1271 >= _1265)
        {
            _1246++;
        }
        int _1280 = 2;
        int _1281 = 2;
        int _1282 = 2;
        _1285._m0 = _1290._m0[(uint(_1280) * _1271) + 0u];
        _1285._m1 = _1290._m0[(uint(_1280) * _1271) + 1u];
        _1285._m2 = _1310._m0[(uint(_1281) * _1271) + 0u];
        float _1324 = _1310._m0[(uint(_1281) * _1271) + 1u].x;
        _1285._m3.x = _31(_1324);
        float _1334 = _1310._m0[(uint(_1281) * _1271) + 1u].y;
        _1285._m3.y = _31(_1334);
        float _1344 = _1310._m0[(uint(_1281) * _1271) + 1u].z;
        _1285._m4.x = _31(_1344);
        float _1354 = _1310._m0[(uint(_1281) * _1271) + 1u].w;
        _1285._m4.y = _31(_1354);
        float _1368 = _1362._m0[(uint(_1282) * _1271) + 0u].x;
        _1285._m5.x = _31(_1368);
        float _1378 = _1362._m0[(uint(_1282) * _1271) + 0u].y;
        _1285._m5.y = _31(_1378);
        float _1388 = _1362._m0[(uint(_1282) * _1271) + 0u].z;
        _1285._m6 = _31(_1388);
        float _1398 = _1362._m0[(uint(_1282) * _1271) + 0u].w;
        _1285._m7 = _31(_1398);
        float _1408 = _1362._m0[(uint(_1282) * _1271) + 1u].x;
        _1285._m8 = _31(_1408);
        float _1418 = _1362._m0[(uint(_1282) * _1271) + 1u].y;
        _1285._m9 = _31(_1418);
        float _1428 = _1362._m0[(uint(_1282) * _1271) + 1u].z;
        _1285._m10 = _31(_1428);
        float _1438 = _1362._m0[(uint(_1282) * _1271) + 1u].w;
        _1285._m11 = _31(_1438);
        vec4 _1443 = _1285._m0;
        vec4 _1446 = _1285._m2;
        vec4 _1449 = _1285._m1;
        vec4 _1452 = vec4(_911._m14, 1.0);
        vec3 _1459 = vec3(dot(_1452, _1443), dot(_1452, _1449), dot(_1452, _1446));
        float _1470 = 0.0039215688593685626983642578125;
        float _1472 = _1459.x;
        float _1475 = _1459.y;
        float _1478 = _1459.z;
        bool _1483 = _42(_1472, _1475, _1478) <= _1470;
        bool _1500;
        if (!_1483)
        {
            float _1487 = _1459.x;
            float _1490 = _1459.y;
            float _1493 = _1459.z;
            _1500 = _37(_1487, _1490, _1493) >= (1.0 - _1470);
        }
        else
        {
            _1500 = _1483;
        }
        if (_1500)
        {
            continue;
        }
        uint _1504 = _1285._m11;
        bool _1508 = _1062 != 0u;
        bool _1515;
        if (_1508)
        {
            _1515 = (_1504 & 512u) != 0u;
        }
        else
        {
            _1515 = _1508;
        }
        bool _1528;
        if (!_1515)
        {
            bool _1520 = _1062 == 0u;
            bool _1527;
            if (_1520)
            {
                _1527 = (_1504 & 1024u) != 0u;
            }
            else
            {
                _1527 = _1520;
            }
            _1528 = _1527;
        }
        else
        {
            _1528 = _1515;
        }
        if (_1528)
        {
            continue;
        }
        vec2 _1532 = vec2(dot(_1227, _1443.xyz), dot(_1227, _1449.xyz));
        vec2 _1542 = vec2(dot(_1231, _1443.xyz), dot(_1231, _1449.xyz));
        float _1552 = 1.0;
        float _1553 = 1.0;
        vec3 _1554 = vec3(0.5, 0.5, 1.0);
        vec3 _1557 = vec3(0.0, 0.0, 1.0);
        uint _1558 = _1285._m7;
        uint _1562 = _1285._m9;
        vec4 _1561 = _105(_1562);
        uvec2 _1567 = _1285._m5;
        vec4 _1566 = _118(_1567);
        vec2 _1571 = _1532 * _1566.xy;
        vec2 _1576 = _1542 * _1566.xy;
        vec2 _1591 = (_1459.xy * _1566.xy) + _1566.zw;
        vec2 _1592 = _1571;
        vec2 _1594 = _1576;
        vec4 _1581 = _135(_1582, _1591, _1592, _1594);
        vec2 _1597 = (_1581.xy * 2.0) - vec2(1.0);
        float _1608 = 1.0 - dot(_1597, _1597);
        _1554 = vec3(_1597, sqrt(_14(_1608)));
        _1557 = _1554;
        _1552 = _1581.z;
        if ((_1558 & 32u) == 0u)
        {
            float _1625 = _1552 - 0.5;
            _10(_1625);
        }
        float _1627 = _1581.w;
        _1553 = _60(_1627);
        bool _1634 = _1553 <= (4.0 * _1470);
        bool _1641;
        if (_1634)
        {
            _1641 = _1561.w <= _1470;
        }
        else
        {
            _1641 = _1634;
        }
        if (_1641)
        {
            continue;
        }
        _1554 = _1557;
        if ((_1504 & 128u) != 0u)
        {
            _1650 = vec3(-_1554.x, -_1554.y, _1554.z);
        }
        else
        {
            _1650 = _1554;
        }
        _1554 = _1650;
        uint _1665 = _1285._m8;
        uint _1669 = _1665;
        float _1668 = 1.0 + (_108(_1669).w * 0.062745101749897003173828125);
        uint _1677 = _1558;
        float _1676 = _105(_1677).z;
        uint _1682 = _1665;
        vec3 _1681 = _105(_1682).xyz;
        float _1695 = _1668 - (_1668 * abs((_1459.z * 2.0) - 1.0));
        _1553 *= _14(_1695);
        float _1699 = _1553;
        if ((_1558 & 1u) != 0u)
        {
            vec3 _1706 = _1681;
            _1681 = vec3(0.0);
            uvec2 _1709 = _1285._m3;
            vec4 _1708 = _118(_1709);
            vec2 _1713 = _1532 * _1708.xy;
            vec2 _1718 = _1542 * _1708.xy;
            vec2 _1732 = (_1459.xy * _1708.xy) + _1708.zw;
            vec2 _1733 = _1713;
            vec2 _1735 = _1718;
            vec4 _1723 = _135(_1582, _1732, _1733, _1735);
            vec4 _1738 = _1723;
            _1723 = _66(_1738);
            _1681 = _1723.xyz;
            float _1750 = (_1723.w - _1470) / (1.0 - _1470);
            _1699 = _14(_1750);
            _1681 *= _1706;
        }
        vec3 _1755 = normalize(vec3(_911._m17[0].z, _911._m17[1].z, _911._m17[2].z));
        float _1764 = dot(_1755, normalize(_1446.xyz));
        float _1770 = _1764;
        vec2 _1775 = _1554.xy * _87(_1770);
        _1554 = vec3(_1775.x, _1775.y, _1554.z);
        if ((_1504 & 16384u) != 0u)
        {
            float _1788 = abs(_1764);
            _1783 = _14(_1788);
        }
        else
        {
            float _1791 = _1764;
            _1783 = _14(_1791);
        }
        float _1778 = _1783;
        float _1795 = ((_1778 * _1699) * _1561.w) * _1676;
        _911._m10 += (_1561.xyz * (_1795 * 64.0));
        uint _1814 = _1285._m10;
        uint _1818 = _1814;
        vec4 _1817 = _105(_1818);
        if ((_1558 & 2u) != 0u)
        {
            uvec2 _1827 = _1285._m4;
            vec4 _1826 = _118(_1827);
            vec2 _1831 = _1532 * _1826.xy;
            vec2 _1836 = _1542 * _1826.xy;
            vec2 _1849 = (_1459.xy * _1826.xy) + _1826.zw;
            vec2 _1850 = _1831;
            vec2 _1852 = _1836;
            _1817 = _135(_1582, _1849, _1850, _1852);
            _1817 *= _1817;
        }
        if ((_1558 & 32u) != 0u)
        {
            uint _1864 = _1558;
            float _1863 = _105(_1864).x;
            uint _1869 = _1558;
            float _1868 = _108(_1869).y;
            float _1875 = _1863;
            float _1873 = mix(_1868, 0.0, _14(_1875));
            float _1884 = _1552 - (_1873 / 255.0);
            float _1879 = float(_14(_1884) > 0.0);
            _1553 *= _1879;
        }
        float _1891 = _1553 * _1778;
        uint _1895 = _1285._m6;
        uint _1899 = _1895;
        vec4 _1904 = _105(_1899) * _1891;
        vec4 _1898 = _26(_1904);
        _911._m11 = max(_911._m11, _1898.x);
        _911._m0 = mix(_911._m0, _1681, _1898.xxx);
        _911._m2 = mix(_911._m2, _1817.xyz, _1898.yyy);
        vec3 _1927 = _1755;
        vec3 _1937 = _1443.xyz + (_1927 * dot(_1443.xyz, _1927));
        _1443 = vec4(_1937.x, _1937.y, _1937.z, _1443.w);
        vec3 _1948 = _1449.xyz + (_1927 * dot(_1449.xyz, _1927));
        _1449 = vec4(_1948.x, _1948.y, _1948.z, _1449.w);
        _1554 = ((normalize(_1443.xyz) * _1554.x) + (normalize(_1449.xyz) * _1554.y)) + (_1927 * _1554.z);
        if ((_1504 & 256u) != 0u)
        {
            vec3 _1975 = mix(_1755, _1554, _1898.www);
            float _1981 = dot(_1975, _1755);
            _1554 = (_911._m6 * _1981) + ((_1975 - (_1755 * _1981)) * dot(_911._m6, _1755));
        }
        else
        {
            if ((_1504 & 64u) != 0u)
            {
                _1554 = mix(mix(_911._m6, _1755, vec3(_1891)), _1554, _1898.www);
            }
            else
            {
                _1554 = mix(_911._m6, _1554, _1898.www);
            }
        }
        _911._m6 = normalize(_1554);
        _911._m3 = mix(_911._m3, _1817.w, _1898.z);
    }
    vec3 _2035 = vec3(0.0);
    vec3 _2036 = vec3(_911._m34.x, _911._m34.y, _911._m34.z);
    vec3 _2044 = vec3(_911._m34.w, _911._m35.x, _911._m35.y);
    vec3 _2052 = vec3(_911._m35.z, _911._m35.w, _911._m36.x);
    vec3 _2060 = vec3(_911._m36.y, _911._m36.z, _911._m36.w);
    vec3 _2068 = ((_2036 - (_2044 * _911._m6.y)) + (_2052 * _911._m6.z)) - (_2060 * _911._m6.x);
    float _2091 = _1065._m7.x * _932._m9.x;
    _2035 += max(_2068 * _14(_2091), vec3(0.0));
    float _2102;
    if (dot(_911._m10, vec3(1.0)) > 0.0)
    {
        _2102 = -_911._m3;
    }
    else
    {
        _2102 = _911._m3;
    }
    _911._m3 = _2102;
    _911._m18 = _2035;
    _911._m19 = _2035;
    float _2119 = 1.0;
    uint _2120 = _1164;
    _2150 _2152;
    while (_2120 < _1165)
    {
        uint _2130 = _1260._m0[_2120];
        uint _2134 = (_2130 >> uint(24)) & 4095u;
        uint _2138 = _2134;
        if (_2138 >= _2134)
        {
            _2120++;
        }
        int _2147 = 4;
        int _2148 = 4;
        int _2149 = 3;
        _2152._m0 = _2156._m0[(uint(_2147) * _2138) + 0u].xyz;
        float _2171 = _2156._m0[(uint(_2147) * _2138) + 0u].w;
        _2152._m1 = _31(_2171);
        _2152._m2 = _2156._m0[(uint(_2147) * _2138) + 1u];
        _2152._m3 = _2156._m0[(uint(_2147) * _2138) + 2u];
        _2152._m4 = _2195._m0[(uint(_2148) * _2138) + 0u];
        _2152._m5 = _2195._m0[(uint(_2148) * _2138) + 1u];
        _2152._m6 = _2195._m0[(uint(_2148) * _2138) + 2u];
        float _2225 = _2156._m0[(uint(_2147) * _2138) + 3u].x;
        _2152._m7.x = _31(_2225);
        float _2235 = _2156._m0[(uint(_2147) * _2138) + 3u].y;
        _2152._m7.y = _31(_2235);
        float _2245 = _2156._m0[(uint(_2147) * _2138) + 3u].z;
        _2152._m7.z = _31(_2245);
        float _2255 = _2156._m0[(uint(_2147) * _2138) + 3u].w;
        _2152._m7.w = _31(_2255);
        _2152._m8 = _2264._m0[(uint(_2149) * _2138) + 0u];
        _2152._m9 = _2264._m0[(uint(_2149) * _2138) + 1u];
        _2152._m10 = _2264._m0[(uint(_2149) * _2138) + 2u];
        float _2294 = _2195._m0[(uint(_2148) * _2138) + 3u].x;
        _2152._m11 = _31(_2294);
        float _2304 = _2195._m0[(uint(_2148) * _2138) + 3u].y;
        _2152._m12 = _31(_2304);
        _2152._m13 = _2195._m0[(uint(_2148) * _2138) + 3u].z;
        float _2322 = _2195._m0[(uint(_2148) * _2138) + 3u].w;
        _2152._m14 = _31(_2322);
        vec3 _2327 = vec3((_911._m14.x * _2152._m4.x) + ((_911._m14.y * _2152._m4.y) + ((_911._m14.z * _2152._m4.z) + _2152._m4.w)), (_911._m14.x * _2152._m5.x) + ((_911._m14.y * _2152._m5.y) + ((_911._m14.z * _2152._m5.z) + _2152._m5.w)), (_911._m14.x * _2152._m6.x) + ((_911._m14.y * _2152._m6.y) + ((_911._m14.z * _2152._m6.z) + _2152._m6.w)));
        vec2 _2394 = _2327.xy / vec2(_2327.z);
        _2327 = vec3(_2394.x, _2394.y, _2327.z);
        _2327.z = (_911._m14.x * _2152._m3.x) + ((_911._m14.y * _2152._m3.y) + ((_911._m14.z * _2152._m3.z) + _2152._m3.w));
        float _2418 = 0.0039215688593685626983642578125;
        float _2419 = _2327.x;
        float _2422 = _2327.y;
        float _2425 = _2327.z;
        bool _2430 = _42(_2419, _2422, _2425) < _2418;
        bool _2447;
        if (!_2430)
        {
            float _2434 = _2327.x;
            float _2437 = _2327.y;
            float _2440 = _2327.z;
            _2447 = _37(_2434, _2437, _2440) >= (1.0 - _2418);
        }
        else
        {
            _2447 = _2430;
        }
        if (_2447)
        {
            continue;
        }
        uint _2451 = _2152._m1;
        uint _2455 = _2152._m12;
        vec3 _2454 = _138(_2455);
        float _2459 = _2152._m13;
        vec3 _2462 = _2152._m0;
        uint _2466 = _2451;
        float _2465 = _105(_2466).y;
        vec3 _2470 = (_2327 * 2.0) - vec3(1.0);
        vec3 _2474 = _2470 * sqrt(((vec3(1.0) - ((_2470.yzx * _2470.yzx) * 0.5)) - ((_2470.zxy * _2470.zxy) * 0.5)) + ((((_2470.yzx * _2470.yzx) * _2470.zxy) * _2470.zxy) / vec3(3.0)));
        float _2518 = 1.0 - ((length(_2474) - _2465) / ((1.0 - _2465) + 9.9999999747524270787835121154785e-07));
        float _2507 = _14(_2518);
        _2507 *= _2507;
        _2507 *= (_2152._m8.w * _2119);
        _2119 *= (1.0 - _2507);
        if (_2507 <= (_2418 * 4.0))
        {
            continue;
        }
        vec3 _2540 = _2454;
        uint _2543 = _2451;
        float _2542 = _108(_2543).z;
        vec3 _2547 = vec3(0.0);
        vec3 _2548 = vec3(0.0);
        vec3 _2549 = _911._m6;
        _2549.x = dot(_2152._m2.xy, _911._m6.xy);
        _2549.y = dot(_2152._m2.zw, _911._m6.xy);
        vec3 _2568 = reflect(-_911._m13, _911._m6);
        vec3 _2575 = (_2152._m9.xyz - _911._m14) / _2568;
        vec3 _2584 = (_2152._m8.xyz - _911._m14) / _2568;
        vec3 _2593 = max(_2575, _2584);
        float _2598 = _2593.x;
        float _2601 = _2593.y;
        float _2604 = _2593.z;
        float _2597 = _42(_2598, _2601, _2604);
        vec3 _2608 = _911._m14 + (_2568 * _2597);
        vec3 _2615 = normalize(_2608 - _2462);
        vec3 _2620 = _2615;
        _2620.x = dot(_2152._m2.xy, _2615.xy);
        _2620.y = dot(_2152._m2.zw, _2615.xy);
        float _2642 = dot(_911._m13, _911._m6);
        float _2636 = _14(_2642);
        float _2644 = 0.0;
        float _2645 = 6.0;
        float _2647 = max(_2644, _2645 - (_2645 * abs(_911._m3)));
        _2548 = textureLod(_2660, vec4(_2620, _2542), _2647).xyz * _2459;
        float _2677 = _2636;
        float _2679 = abs(_911._m3);
        vec3 _2680 = _911._m2;
        vec3 _2673 = _157(_2677, _2679, _2680);
        _2548 *= _2673;
        float _2691 = _2507;
        _911._m20 += ((_2548 * _2540) * _14(_2691));
        if (_2119 <= (_2418 * 4.0))
        {
            break;
        }
    }
    uint _2706 = _1160;
    _2150 _2735;
    vec3 _3019;
    float _3096;
    float _3114;
    _3484 _3486;
    uint _3607;
    _3484 _3631;
    vec3 _4105;
    vec3 _4118;
    while (_2706 < _1161)
    {
        uint _2716 = _1260._m0[_2706];
        uint _2720 = _2716 & 4095u;
        uint _2723 = _2720;
        if (_2723 >= _2720)
        {
            _2706++;
        }
        int _2732 = 4;
        int _2733 = 4;
        int _2734 = 3;
        _2735._m0 = _2156._m0[(uint(_2732) * _2723) + 0u].xyz;
        float _2750 = _2156._m0[(uint(_2732) * _2723) + 0u].w;
        _2735._m1 = _31(_2750);
        _2735._m2 = _2156._m0[(uint(_2732) * _2723) + 1u];
        _2735._m3 = _2156._m0[(uint(_2732) * _2723) + 2u];
        _2735._m4 = _2195._m0[(uint(_2733) * _2723) + 0u];
        _2735._m5 = _2195._m0[(uint(_2733) * _2723) + 1u];
        _2735._m6 = _2195._m0[(uint(_2733) * _2723) + 2u];
        float _2800 = _2156._m0[(uint(_2732) * _2723) + 3u].x;
        _2735._m7.x = _31(_2800);
        float _2810 = _2156._m0[(uint(_2732) * _2723) + 3u].y;
        _2735._m7.y = _31(_2810);
        float _2820 = _2156._m0[(uint(_2732) * _2723) + 3u].z;
        _2735._m7.z = _31(_2820);
        float _2830 = _2156._m0[(uint(_2732) * _2723) + 3u].w;
        _2735._m7.w = _31(_2830);
        _2735._m8 = _2264._m0[(uint(_2734) * _2723) + 0u];
        _2735._m9 = _2264._m0[(uint(_2734) * _2723) + 1u];
        _2735._m10 = _2264._m0[(uint(_2734) * _2723) + 2u];
        float _2864 = _2195._m0[(uint(_2733) * _2723) + 3u].x;
        _2735._m11 = _31(_2864);
        float _2874 = _2195._m0[(uint(_2733) * _2723) + 3u].y;
        _2735._m12 = _31(_2874);
        _2735._m13 = _2195._m0[(uint(_2733) * _2723) + 3u].z;
        float _2892 = _2195._m0[(uint(_2733) * _2723) + 3u].w;
        _2735._m14 = _31(_2892);
        float _2897 = 0.0039215688593685626983642578125;
        vec4 _2898 = vec4(_911._m14, 1.0);
        float _2905 = 1.0 / dot(_2898, _2735._m6);
        vec3 _2911 = vec3(dot(_2898, _2735._m4) * _2905, dot(_2898, _2735._m5) * _2905, dot(_2898, _2735._m3));
        uint _2929 = _2735._m1;
        uint _2932 = _1062;
        _2932 |= 64u;
        float _2936 = _2911.x;
        float _2939 = _2911.y;
        float _2942 = _2911.z;
        bool _2947 = _42(_2936, _2939, _2942) <= _2897;
        bool _2964;
        if (!_2947)
        {
            float _2951 = _2911.x;
            float _2954 = _2911.y;
            float _2957 = _2911.z;
            _2964 = _37(_2951, _2954, _2957) >= (1.0 - _2897);
        }
        else
        {
            _2964 = _2947;
        }
        bool _2972;
        if (!_2964)
        {
            _2972 = (_2929 & _2932) != 0u;
        }
        else
        {
            _2972 = _2964;
        }
        if (_2972)
        {
            continue;
        }
        if ((_2929 & 3u) == 2u)
        {
            vec2 _2991 = fract((_2911.xy * _932._m10.xy) + _932._m10.zw);
            _2911 = vec3(_2991.x, _2991.y, _2911.z);
        }
        vec3 _2994 = _2735._m0;
        float _2997 = 1.0;
        float _2998 = 1.0;
        vec3 _2999 = vec3(0.0, 0.0, 1.0);
        vec3 _3000 = vec3(0.0, 0.0, 1.0);
        uint _3001 = _2735._m1;
        vec3 _3004 = (_2911 * 2.0) - vec3(1.0);
        vec2 _3009 = _2911.xy;
        vec3 _3012 = _2735._m10.xyz;
        if ((_3001 & 3u) == 2u)
        {
            _3019 = _3012;
        }
        else
        {
            _3019 = normalize(_2994 - _911._m14);
        }
        _2999 = _3019;
        _2999 = _2999;
        float _3036 = dot(_911._m6, _2999);
        float _3031 = _14(_3036);
        uvec2 _3039 = _2735._m7.zw;
        vec4 _3038 = _118(_3039);
        float _3045 = TEXTURE_LOD(_3046, vec4((_3009 * _3038.xy) + _3038.zw, 0.0, 0.0).xy, vec4((_3009 * _3038.xy) + _3038.zw, 0.0, 0.0).w).x;
        float _3072 = _3045 * _3045;
        uint _3076 = _3001 & 3u;
        bool _3081 = _3076 == 1u;
        bool _3093;
        if (!_3081)
        {
            bool _3086 = _3076 == 0u;
            bool _3092;
            if (_3086)
            {
                _3092 = _2735._m8.z != 0.0;
            }
            else
            {
                _3092 = _3086;
            }
            _3093 = _3092;
        }
        else
        {
            _3093 = _3081;
        }
        bool _3079 = _3093;
        if (_3079)
        {
            float _3099 = _2735._m8.w;
            _3096 = _14(_3099);
        }
        else
        {
            _3096 = 0.5;
        }
        float _3094 = _3096;
        bool _3107 = _3076 == 0u;
        bool _3113;
        if (_3107)
        {
            _3113 = _2735._m8.z != 0.0;
        }
        else
        {
            _3113 = _3107;
        }
        if (_3113)
        {
            float _3122 = sqrt(dot(_3004, _3004));
            _3114 = min(0.9921875, _14(_3122));
        }
        else
        {
            _3114 = _2911.z;
        }
        float _3105 = _3114;
        uvec2 _3130 = _2735._m7.xy;
        vec4 _3129 = _118(_3130);
        vec2 _3135 = vec2(_3105, _3094);
        float _3139 = TEXTURE_LOD(_3046, vec4((_3135 * _3129.xy) + _3129.zw, 0.0, 0.0).xy, vec4((_3135 * _3129.xy) + _3129.zw, 0.0, 0.0).w).x;
        _3139 *= _3139;
        _2997 = _3139 * _3072;
        if ((_3001 & 48u) != 0u)
        {
            vec4 _3177 = _2735._m10;
            vec4 _3180 = _2735._m8;
            vec4 _3183 = _2735._m9;
            float _3186 = dot(_911._m14, _3177.xyz) + _3177.w;
            if (_3186 < 0.0)
            {
                continue;
            }
            float _3200 = length(_3177.xyz);
            float _3207 = _3186 * 50.0;
            float _3204 = _14(_3207);
            _2997 *= (_3204 * _3204);
            _3186 /= _3200;
            _3177 /= vec4(_3200);
            vec3 _3221 = reflect(-_911._m13, _911._m6);
            if (dot(_3221, _3177.xyz) > 0.0)
            {
                _3221 = reflect(_3221, _3177.xyz);
            }
            float _3239 = dot(_3221, _3177.xyz);
            float _3244 = _3186 / _3239;
            vec3 _3248 = _911._m14 - (_3221 * _3244);
            vec3 _3255 = _3248 - _2994;
            float _3259 = dot(_3255, _3180.xyz) / _3180.w;
            float _3267 = dot(_3255, _3183.xyz) / _3183.w;
            if ((_3001 & 48u) == 32u)
            {
                vec2 _3280 = vec2(_3259, _3267);
                float _3284 = 1.0 / max(1.0, length(vec2(_3259, _3267)));
                _3259 *= (_3284 * _3180.w);
                _3267 *= (_3284 * _3183.w);
            }
            else
            {
                float _3306 = abs(_3259);
                float _3308 = _3259;
                _3259 = (_14(_3306) * _87(_3308)) * _3180.w;
                float _3317 = abs(_3267);
                float _3319 = _3267;
                _3267 = (_14(_3317) * _87(_3319)) * _3183.w;
            }
            vec3 _3326 = (_3180.xyz * _3259) + (_3183.xyz * _3267);
            _2994 += _3326;
            _2999 = normalize(_2994 - _911._m14);
            _2999 = _2999;
        }
        else
        {
            uint _3346 = (_2735._m14 >> uint(16)) & 255u;
            if (_3346 == 0u)
            {
                vec4 _3355 = _2735._m9;
                if (dot(_3355.xyz, _911._m14) < (_3355.w - _2897))
                {
                    continue;
                }
            }
            else
            {
                if (_3346 == 1u)
                {
                    vec3 _3376 = _2735._m9.xyz;
                    float _3381 = _2735._m9.w;
                    uint _3385 = _31(_3381);
                    vec3 _3380 = (((_112(_3385) * 2.0) - vec3(1.0)) * _3376) + _2994;
                    vec3 _3394 = abs((_911._m14 - _3380) / _3376);
                    float _3402 = _3394.x;
                    float _3405 = _3394.y;
                    float _3408 = _3394.z;
                    if (_37(_3402, _3405, _3408) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2997 <= (_2897 / 256.0))
        {
            continue;
        }
        float _3424 = 1.0;
        if ((_2929 & 4u) != 0u)
        {
            float _3431 = float(_2735._m14 & 255u) / 255.0;
            float _3437 = 0.00999999977648258209228515625;
            vec3 _3439 = _911._m14 + (_911._m6 * _3437);
            uint _3447 = 0u;
            if ((_2929 & 3u) == 0u)
            {
                vec3 _3453 = _3439 - _2735._m2.xyz;
                float _3459 = _3453.x;
                float _3462 = _3453.y;
                float _3465 = _3453.z;
                _3447 = _48(_3459, _3462, _3465);
            }
            else
            {
                if ((_2929 & 3u) == 2u)
                {
                    float _3475 = 0.0;
                    for (; _3447 < 3u; _3447++)
                    {
                        int _3483 = 5;
                        _3486._m0 = _3490._m0[(uint(_3483) * ((_2929 >> uint(22)) + _3447)) + 0u];
                        _3486._m1 = _3490._m0[(uint(_3483) * ((_2929 >> uint(22)) + _3447)) + 1u];
                        _3486._m2 = _3490._m0[(uint(_3483) * ((_2929 >> uint(22)) + _3447)) + 2u];
                        _3486._m3 = _3490._m0[(uint(_3483) * ((_2929 >> uint(22)) + _3447)) + 3u];
                        _3486._m4 = _3490._m0[(uint(_3483) * ((_2929 >> uint(22)) + _3447)) + 4u];
                        vec2 _3547 = vec2(dot(_3439, _3486._m0.xyz) + _3486._m0.w, dot(_3439, _3486._m1.xyz) + _3486._m1.w);
                        _3547 = abs((_3547 * 2.0) - vec2(1.0));
                        bool _3572 = _3547.x < 1.0;
                        bool _3578;
                        if (_3572)
                        {
                            _3578 = _3547.y < 1.0;
                        }
                        else
                        {
                            _3578 = _3572;
                        }
                        if (_3578)
                        {
                            _3475 = (1.0 - max(_3547.x, _3547.y)) * _932._m11.w;
                            break;
                        }
                    }
                    _3447 = min(2u, _3447);
                    uint _3595 = uint(_911._m16.x) ^ (uint(_911._m16.y) << uint(1));
                    if (_932._m12.w > 0.0)
                    {
                        _3607 = uint(_932._m13.x);
                    }
                    else
                    {
                        _3607 = 0u;
                    }
                    _3595 ^= _3607;
                    _3447 += uint(int(((float(_3595 & 3u) * 0.25) + 0.125) > _3475));
                }
            }
            int _3630 = 5;
            _3631._m0 = _3490._m0[(uint(_3630) * ((_2929 >> uint(22)) + _3447)) + 0u];
            _3631._m1 = _3490._m0[(uint(_3630) * ((_2929 >> uint(22)) + _3447)) + 1u];
            _3631._m2 = _3490._m0[(uint(_3630) * ((_2929 >> uint(22)) + _3447)) + 2u];
            _3631._m3 = _3490._m0[(uint(_3630) * ((_2929 >> uint(22)) + _3447)) + 3u];
            _3631._m4 = _3490._m0[(uint(_3630) * ((_2929 >> uint(22)) + _3447)) + 4u];
            vec4 _3687 = vec4((_3439.x * _3631._m0.x) + ((_3439.y * _3631._m0.y) + ((_3439.z * _3631._m0.z) + _3631._m0.w)), (_3439.x * _3631._m1.x) + ((_3439.y * _3631._m1.y) + ((_3439.z * _3631._m1.z) + _3631._m1.w)), (_3439.x * _3631._m2.x) + ((_3439.y * _3631._m2.y) + ((_3439.z * _3631._m2.z) + _3631._m2.w)), (_3439.x * _3631._m3.x) + ((_3439.y * _3631._m3.y) + ((_3439.z * _3631._m3.z) + _3631._m3.w)));
            vec3 _3774 = _3687.xyz / vec3(_3687.w);
            _3687 = vec4(_3774.x, _3774.y, _3774.z, _3687.w);
            bool _3782 = min(_3687.x, _3687.y) > 0.0;
            bool _3791;
            if (_3782)
            {
                _3791 = max(_3687.x, _3687.y) < 1.0;
            }
            else
            {
                _3791 = _3782;
            }
            if (_3791)
            {
                vec2 _3803 = (_3687.xy * _3631._m4.xy) + _3631._m4.zw;
                _3687 = vec4(_3803.x, _3803.y, _3687.z, _3687.w);
                if (false)
                {
                    _3424 = textureLod(_3811, vec3(_3687.xyz.xy, _3687.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3818 = (_3687.xy * _932._m14.xy) + vec2(0.5);
                    vec2 _3827 = floor(_3818);
                    vec2 _3830 = _3818 - _3827;
                    _3827 -= vec2(0.5);
                    vec2 _3837 = vec2(4.0) - (_3830 * 3.0);
                    vec2 _3842 = vec2(7.0);
                    vec2 _3845 = vec2(1.0) + (_3830 * 3.0);
                    vec2 _3850 = (_3827 + (((vec2(3.0) - (_3830 * 2.0)) / _3837) - vec2(2.0))) * _932._m14.zw;
                    vec2 _3865 = (_3827 + ((vec2(3.0) + _3830) / _3842)) * _932._m14.zw;
                    vec2 _3877 = (_3827 + ((_3830 / _3845) + vec2(2.0))) * _932._m14.zw;
                    vec3 _3901 = vec3(_3850.x, _3850.y, _3687.z);
                    _3424 = (_3837.x * _3837.y) * textureLod(_3811, vec3(_3901.xy, _3901.z), 0.0);
                    vec3 _3917 = vec3(_3865.x, _3850.y, _3687.z);
                    _3424 += ((_3842.x * _3837.y) * textureLod(_3811, vec3(_3917.xy, _3917.z), 0.0));
                    vec3 _3935 = vec3(_3877.x, _3850.y, _3687.z);
                    _3424 += ((_3845.x * _3837.y) * textureLod(_3811, vec3(_3935.xy, _3935.z), 0.0));
                    vec3 _3953 = vec3(_3850.x, _3865.y, _3687.z);
                    _3424 += ((_3837.x * _3842.y) * textureLod(_3811, vec3(_3953.xy, _3953.z), 0.0));
                    vec3 _3971 = vec3(_3865.x, _3865.y, _3687.z);
                    _3424 += ((_3842.x * _3842.y) * textureLod(_3811, vec3(_3971.xy, _3971.z), 0.0));
                    vec3 _3989 = vec3(_3877.x, _3865.y, _3687.z);
                    _3424 += ((_3845.x * _3842.y) * textureLod(_3811, vec3(_3989.xy, _3989.z), 0.0));
                    vec3 _4007 = vec3(_3850.x, _3877.y, _3687.z);
                    _3424 += ((_3837.x * _3845.y) * textureLod(_3811, vec3(_4007.xy, _4007.z), 0.0));
                    vec3 _4025 = vec3(_3865.x, _3877.y, _3687.z);
                    _3424 += ((_3842.x * _3845.y) * textureLod(_3811, vec3(_4025.xy, _4025.z), 0.0));
                    vec3 _4043 = vec3(_3877.x, _3877.y, _3687.z);
                    _3424 += ((_3845.x * _3845.y) * textureLod(_3811, vec3(_4043.xy, _4043.z), 0.0));
                    _3424 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3424 = float((_2929 & 3u) == 2u);
            }
            float _4057 = float((_2929 >> uint(16)) & 63u) / 63.0;
            float _4071 = ((_3424 * _4057) + 1.0) - _4057;
            _3424 = _14(_4071);
        }
        uint _4074 = _2735._m12;
        vec3 _4073 = (_138(_4074) * _3424) * _2997;
        _2998 *= _2735._m13;
        vec3 _4086 = _4073;
        vec3 _4088 = normalize(_2994 - _911._m14);
        float _4094 = dot(_911._m6, _4088);
        float _4100 = _4094;
        float _4099 = _87(_4100);
        if (_4099 >= 0.0)
        {
            _4105 = _4088;
        }
        else
        {
            _4105 = reflect(_4088, _911._m6);
        }
        _4088 = _4105;
        if (_4099 >= 0.0)
        {
            _4118 = vec3(1.0);
        }
        else
        {
            _4118 = _911._m0;
        }
        vec3 _4115 = _4118;
        float _4129 = dot(_911._m6, _4088);
        float _4131 = _4094;
        _4094 = mix(_14(_4129), _14(_4131), _911._m11);
        _911._m19 += (_4086 * _4094);
        vec3 _4145 = _911._m6;
        vec3 _4148 = _911._m13;
        vec3 _4151 = _4088;
        vec3 _4153 = _911._m2;
        float _4156 = _911._m3;
        vec3 _4144 = _151(_4145, _4148, _4151, _4153, _4156);
        vec3 _4160 = ((((_4086 * _4094) * _4144) * _2998) * _4115) + _911._m20;
        vec3 _4173 = vec3(40.0);
        _911._m20 = min(_4160, _4173);
    }
    _911._m19 = _911._m19;
    _911._m20 += _911._m10;
    _911._m19 *= _911._m0;
    _911._m21 = _911._m19 + _911._m20;
    float _4201 = 0.89999997615814208984375;
    float _4203 = 0.0076199998147785663604736328125;
    vec3 _4205 = normalize(refract(_911._m6, -_911._m13, _4201));
    vec3 _4250 = _911._m14 + (_4205 * _4203);
    mat4 _4251 = mat4(vec4(_932._m15), vec4(_932._m16), vec4(_932._m17), vec4(_932._m18));
    vec4 _4214 = _76(_4250, _4251);
    
    // FIX FOR GLASS    
    _4214.x += vk3d_params[VIEW].stereo.x * (_4214.w - vk3d_params[VIEW].stereo.y)* 0.5;
    
    vec2 _4258 = _4214.xy / vec2(_4214.w);
    _4214 = vec4(_4258.x, _4258.y, _4214.z, _4214.w);
    float _4261 = min(_911._m3, 0.99989998340606689453125);
    float _4266 = fract(_4261 * 4.0);
    vec3 _4270 = vec3(0.0);
    if (_4261 > 0.97500002384185791015625)
    {
        _4270 = TEXTURE_LOD(_4276, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz;
    }
    else
    {
        if (_4261 > 0.75)
        {
            _4270 = mix(TEXTURE_LOD(_4298, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4276, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, vec3(_4266));
        }
        else
        {
            if (_4261 > 0.5)
            {
                _4270 = mix(TEXTURE_LOD(_4337, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4298, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, vec3(_4266));
            }
            else
            {
                if (_4261 > 0.25)
                {
                    _4270 = mix(TEXTURE_LOD(_4376, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4337, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, vec3(_4266));
                }
                else
                {
                    _4270 = mix(TEXTURE_LOD(_4411, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4376, vec4(_4214.xy, 0.0, 0.0).xy, vec4(_4214.xy, 0.0, 0.0).w).xyz, vec3(_4266));
                }
            }
        }
    }
    _911._m21 = mix(_911._m0 * _4270, _911._m19, vec3(_911._m11)) + _911._m20;
    _4460 = vec4(_911._m21, _911._m11);
    vec2 _4469 = _911._m16.xy * _932._m6.zw;

    float _4477 = _911._m16.z;
    vec4 _4480 = vec4(0.0);
    float _4481 = 1.0;
    float _4483 = _932._m19.w;
    uint _4482 = _31(_4483);
    if ((_4482 & 6u) != 0u)
    {
        vec2 _4493 = _4469 + vec2(0.0);
        vec3 _4497 = _932._m20.xyz;
        float _4501 = 0.100000001490116119384765625;
        float _4503 = _932._m21.y;
        float _4506 = _932._m20.z;
        float _4509 = 0.0;
        float _4511 = _4477;
        vec4 _4513 = _932._m7;
        float _4516 = 1.0;
        bool _4517 = false;
        float _4510 = _166(_4511, _4513, _4516, _4517);
        _4509 = pow((_4510 - _4501) / (_4503 - _4501), 0.5);
        _4509 = (_4509 * (_4506 - 1.0)) / _4506;
        vec4 _4533 = vec4(_4493, _4509, 0.0);

        // Correction for Volumetrics on Glass - colour inversion
        _4533.x -= vk3d_params[VIEW].stereo.x* 0.5;

        vec3 _4559 = textureLod(_4542, vec4(_4533.xyz, 0.0).xyz, vec4(_4533.xyz, 0.0).w).xyz;
        _4480 = vec4(_4559.x, _4559.y, _4559.z, _4480.w);
        vec2 _4562 = textureLod(_4563, vec4(_4533.xyz, 0.0).xyz, vec4(_4533.xyz, 0.0).w).xy;
        _4480.w = _4562.x;
        _4481 = _4562.y;
    }
    if ((_4482 & 2u) != 0u)
    {
        vec4 _4591 = vec4(0.0);
        vec3 _4592 = _932._m4.xyz;
        float _4597 = _4477;
        vec4 _4599 = _932._m7;
        float _4602 = 1.0;
        bool _4603 = false;
        float _4596 = _166(_4597, _4599, _4602, _4603);
        vec3 _4605 = mix(_932._m22.xyz, _932._m23.xyz, vec3(_4469.x * _932._m24.z));
        vec3 _4620 = mix(_932._m25.xyz, _932._m26.xyz, vec3(_4469.x * _932._m24.z));
        vec3 _4636 = mix(_4620, _4605, vec3(1.0 - (_4469.y * _932._m24.w)));
        vec4 _4647 = vec4(0.0);
        vec3 _4648 = normalize(_4636);
        float _4651 = _4648.z;
        _4647.x = clamp(_90(_4651) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _4660 = _4648.y;
        float _4663 = _4648.x;
        _4647.y = _100(_4660, _4663) / 6.283185482025146484375;
        _4647.z = sqrt(_4596 * _932._m27.w);
        _4647.z = clamp(_4647.z, 0.015625, 0.984375);
        vec3 _4690 = textureLod(_4683, _4647.xyz, _4647.w).xyz;
        _4591 = vec4(_4690.x, _4690.y, _4690.z, _4591.w);
        vec3 _4699 = _4460.xyz + (_4591.xyz * _4481);
        _4460 = vec4(_4699.x, _4699.y, _4699.z, _4460.w);
    }
    if ((_4482 & 4u) != 0u)
    {
        vec3 _4714 = (_4460.xyz * _4480.w) + _4480.xyz;
        _4460 = vec4(_4714.x, _4714.y, _4714.z, _4460.w);
    }
    vec3 _4722 = _4460.xyz + _1065._m8.xyz;
    _4460 = vec4(_4722.x, _4722.y, _4722.z, _4460.w);
    _4460.w = 1.0;
    _4727 = vec4(0.0);
    _4728 = vec4(0.0);
    if (_932._m28.w > 0.0)
    {
        vec2 _4735 = gl_FragCoord.xy * _932._m6.xy;
        bool _4742 = (gl_FragCoord.z < TEXTURE_LOD(_4746, vec4(_4735, 0.0, 0.0).xy, vec4(_4735, 0.0, 0.0).w).x) ? true : false;
        if (_4742 == false)
        {
            _4727 = _4460;
        }
        _4460 *= float(_4742 == true);
        _4728.x = _4460.w;
    }
}




